import javafx.scene.paint.Color;
import javafx.scene.paint.PhongMaterial;
import javafx.scene.shape.Box;

/**
 * [v
 */
public class ARSpriteWarp extends ARSprite {

	/** }eA */
	private static final PhongMaterial		MATERIALS		= new PhongMaterial(Color.color(0.9, 0.9, 0.0, 0.3));

	/** AvP[V */
	public		ARApplication				application		= null;

	/** [v */
	private		Box							boxWarp			= null;

	/**  */
	private		int							time			= 0;

	/**
	 * RXgN^
	 * @param application ARApplication
	 * @param spriteShip ARSprite @
	 */
	public ARSpriteWarp(ARApplication application, ARSpriteShip spriteShip) {

		super(application);

		// AvP[Vێ
		this.application = application;

		// [v
		boxWarp = new Box(0.8, 0.4, 0.0);

		// }eAݒ
		boxWarp.setMaterial(MATERIALS);

		// W
		boxWarp.setTranslateX(spriteShip.getTranslateX());
		boxWarp.setTranslateY(spriteShip.getTranslateY());
		boxWarp.setTranslateZ(300);

		// [vǉ
		this.getChildren().add(boxWarp);

	} // end ARSpriteWarp

	/**
	 * s
	 */
	public void run(){

		// ԁ{P
		time++;

		// PbA
		if(time < 60){

			// svZ
			double depth = time / 60.0 * 300;

			// sS_vZ
			double zCenter = 300 - depth / 2;

			// Wݒ
			boxWarp.setTranslateZ(zCenter);

			// sݒ
			boxWarp.setDepth(depth);

		// R.TbA
		}else if(time < 210){

			// ȂɂȂ

		// SDTb
		}else if(time < 270){

			// ԌvZ
			int time1 = 60 - (time - 210);

			// svZ
			double depth = time1 / 60.0 * 300;

			// sS_vZ
			double zCenter = 300 - depth / 2;

			// Wݒ
			boxWarp.setTranslateZ(zCenter);

			// sݒ
			boxWarp.setDepth(depth);

		// SDTb
		}else if(time == 270){

			// AvP[Vm[h폜
			application.removeNode(this);

		} // end if

	} // end run

}
