import java.util.ArrayList;
import java.util.List;

import javafx.collections.ObservableList;
import javafx.scene.Group;
import javafx.scene.Node;

/**
 * 3DplNX
 * <pre>
 * Ԃ̐sAKXAm[hrun\bhĂяo܂B
 * L[̉Ԃ𐧌䂵܂B
 * </pre>
 */
public class ARPanel3D extends Group implements ARConstant {

	/** AvP[V */
	private		ARApplication		application		= null;

	/**
	 * RXgN^
	 * @param application AvP[V
	 */
	public ARPanel3D(ARApplication application){

		// X[p[NXĂяo
		super();

		// AvP[Vێ
		this.application = application;

		// Ăяo
		init();

	} // end ARPanel3D

	/**
	 * 
	 * <pre>
	 * plNX̏s܂B
	 * </pre>
	 */
	public void init(){

	} // end init

	/**
	 * Jn
	 * <pre>
	 * IuWFNg̏Jn܂B
	 * </pre>
	 */
	public void start(){

	}

	/**
	 * s
	 * <pre>
	 * ^C}[IɌĂ΂܂B
	 * </pre>
	 */
	synchronized public void run(){

		// AvP[Ṽ|[YtO擾\bhĂяo
		boolean flgPause = application.isPause();

		// Q[̏ꍇi|[Ył͂ȂꍇjA
		if(!flgPause){

			//
			// m[h
			//

			// m[hꗗ擾
			List<Node> nodeLst = this.getNodeLst();

			// m[hꗗ̌擾
			int countNodeLst = nodeLst.size();

			// m[hꗗ̌A[v
			for(int j = 0; j < countNodeLst; j++){

				// m[h擾
				Node node = nodeLst.get(j);

				// _~[m[h̏ꍇA
				if(node instanceof ARNodeDummy){

					// Ȃ

				// ̏ꍇA
				}else if(node instanceof ARSpriteStardust){

					// XvCg擾
					ARSpriteStardust sprite = (ARSpriteStardust)node;

					// XvCgN
					sprite.run();

				// XvCg̏ꍇA
				}else if(node instanceof ARSprite){

					// XvCg擾
					ARSprite sprite = (ARSprite)node;

					// XvCgN
					sprite.run();

				}

			} // end for m[hꗗ̌A[v

		} // end if Q[̏ꍇi|[Ył͂Ȃꍇj

	} // end run

	/**
	 * |̎
	 * <pre>
	 * ^C}[IɌĂ΂܂B
	 * </pre>
	 */
	synchronized public void clean(){

		//
		// m[hꗗȂꍇ́A|Bih~j
		// m[h̎sƂ͕ʂɂiUj
		//

		// m[hꗗ擾
		ObservableList<Node> nodeLst = this.getNodeLst();

		// m[hꗗ̌擾
		int countNodeLst = nodeLst.size();

		// m[hꗗ̌1000𒴂ꍇA
		if(countNodeLst > 1000){

			// ꎞIɃm[hꗗi[Nj쐬
			ArrayList<Node> nodeLstWk = new ArrayList<Node>(1000);

			// m[hꗗ̌A[v
			for(int j = 0; j < countNodeLst; j++){

				// m[h擾
				Node node = (Node)nodeLst.get(j);

				// m[h_~[m[hȊȌꍇA
				if(!(node instanceof ARNodeDummy)){

					// m[hꗗi[Njɒǉ
					nodeLstWk.add(node);

				}

			} // end for m[hꗗ̌A[v

			// m[hꗗւ
			nodeLst.setAll(nodeLstWk);

		} // end if m[hꗗ̌1000𒴂ꍇ

	} // end clean

	/**
	 * m[hǉ
	 * @param node m[h
	 */
	public void addNode(Node node){

		// m[hꗗ擾
		List<Node> nodeLst = this.getNodeLst();

		// m[hǉ
		nodeLst.add(node);

	} // end addNode

	/**
	 * m[h폜
	 * <pre>
	 * m[h폜܂B
	 * \bhł́A_~[m[hɒuArun\bh̒ō폜܂B
	 * nullɒułȂ
     *  ListNXremove\bh𑽗p邱ƂŔzRs[𑽗p邱Ƃ邽
	 * idȂ邱Ƃł邾j
	 * </pre>
	 * @param node m[h
	 */
	public void removeNode(Node node){

		// m[hꗗ擾
		List<Node> nodeLst = this.getNodeLst();

		// CfbNX߂
		int index = nodeLst.indexOf(node);

		// CfbNX擾łꍇA
		if(index != -1){

			// _~[m[hɒu
			nodeLst.set(index, new ARNodeDummy(this.application));

		}

	} // end removeNode

	/**
	 * m[hꗗ擾
	 * @return ObservableList<Node> m[hꗗ
	 */
	public ObservableList<Node> getNodeLst(){

		// List擾
		ObservableList<Node> nodeLst = this.getChildren();

		// ^[
		return nodeLst;

	} // end getNodeLst

	/**
	 * AvP[V擾
	 * @return ARApplication AvP[V
	 */
	public ARApplication getApplication(){

		// AvP[V^[
		return application;

	} // end getApplication

}
