import javafx.scene.paint.Color;
import javafx.scene.paint.PhongMaterial;
import javafx.scene.shape.Sphere;

/**
 * 
 */
public class ARSpriteBomb extends ARSprite {

	/** ̐F */
	private static final Color[]		COLORS			= new Color[]{
		Color.color(0.6, 0.6, 0.0, 0.2),
		Color.color(0.6, 0.6, 0.0, 0.4),
		Color.color(0.8, 0.8, 0.0, 0.6),
		Color.color(0.8, 0.8, 0.0, 0.8),
		Color.color(0.9, 0.9, 0.0, 1.0),
		Color.color(0.8, 0.8, 0.0, 0.8),
		Color.color(0.8, 0.8, 0.0, 0.6),
		Color.color(0.6, 0.6, 0.0, 0.4),
		Color.color(0.6, 0.6, 0.0, 0.2)
	};

	/** AvP[V */
	public		ARApplication			application		= null;

	/** XvCg */
	public		ARSprite				sprite			= null;

	/**  */
	private		Sphere					sphere			= null;

	/** }eA */
	private		PhongMaterial			material		= null;

	/**  */
	private		int						time			= 0;

	/** a */
	private		double					aRadius			= 0;

	/** Fʒu */
	private		int						posColors		= 0;

	/**
	 * RXgN^
	 * @param application ARApplication
	 * @param group Group XvCg
	 */
	public ARSpriteBomb(ARApplication application, ARSprite sprite) {

		super(application);

		// AvP[Vێ
		this.application = application;

		// XvCgێ
		this.sprite = sprite;

		// ꏊݒ
		this.setTranslateX(sprite.getTranslateX());
		this.setTranslateY(sprite.getTranslateY());
		this.setTranslateZ(sprite.getTranslateZ() - 1);

		// avZ
		aRadius = 0.02;

		// 𐶐
		sphere = new Sphere(0.0);

		// }eA𐶐
		material = new PhongMaterial(COLORS[0]);

		// }eAݒ
		sphere.setMaterial(material);

		// ǉ
		this.getChildren().add(sphere);

	} // end ARSpriteBomb

	/**
	 * s
	 */
	public void run(){

		// ԁ{P
		time++;

		// 0.5b
		if(time < 30){

			// aݒ
			sphere.setRadius(sphere.getRadius() + aRadius);

		// 0.5b
		}else{

			// 0.2bPʂ̏ꍇA
			if(time % 12 == 0){

				// Fʒu{P
				posColors++;

				// FȂꍇA
				if(posColors >= COLORS.length){

					// AvP[Vm[h폜
					application.removeNode(this);

					// ^[
					return;

				}

				// FύX
				material.setDiffuseColor(COLORS[posColors]);

				// FʒuSɂȂꍇA
				if(posColors == 4){

					// XvCg폜
					application.removeNode(sprite);

				}

			} // end if // 0.2bPʂ̏ꍇ

		} // end if 0.5b

	} // end run

}
